﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SyncfusionMvcApplication121;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript;
using Syncfusion.Linq;
using System.Collections;
using System.Web.Http;
namespace SyncfusionMvcApplication121.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
        {
            
            return View();
        }
        public JsonResult DataSource(DataManager dm)
        {
            IEnumerable Data = new NorthwindDataContext().OrdersViews.ToList();
            DataResult result = new DataResult(); 


           // IEnumerable Data = data.ToList();
            DataOperations operation = new DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                Data = operation.PerformSorting(Data, dm.Sorted);
            }
            int count = Data.AsQueryable().Count();
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                Data = operation.PerformWhereFilter(Data, dm.Where, dm.Where[0].Operator);
            }
            count = Data.AsQueryable().Count();
            if (dm.Skip != 0) //Paging
            {
                Data = operation.PerformSkip(Data, dm.Skip);
            }
            if (dm.Take != 0) //Paging
            {
                Data = operation.PerformTake(Data, dm.Take);
            }
            return Json(new { result = Data, count = count });
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
           
        }
    }
}
